#pragma once

// EVR𗘗pȂꍇ̓RgAEg
//#define USE_MEDIA_FOUNDATION

#include <streams.h>
#include <d3d9.h>
#include <vmr9.h>
#ifdef USE_MEDIA_FOUNDATION
#include <mfapi.h>
#include <mfidl.h>
#include <mferror.h>
#include <evr9.h>
#endif

// guidɓĂȂǉGUID
#ifndef WAVE_FORMAT_AAC
#define WAVE_FORMAT_AAC 0x00FF
#endif

// AAC Mediatype {000000FF-0000-0010-8000-00AA00389B71}
#ifndef MEDIASUBTYPE_AAC
DEFINE_GUID(MEDIASUBTYPE_AAC,WAVE_FORMAT_AAC, 0x0000, 0x0010, 0x80, 0x00, 0x00, 0xaa, 0x00, 0x38, 0x9b, 0x71);
#endif
                         
// ColorSpace Converter {1643E180-90F5-11CE-97D5-00AA0055595A}
#ifndef CLSID_ColorSpaceConverter
DEFINE_GUID(CLSID_ColorSpaceConverter, 0x1643E180, 0x90F5, 0x11CE, 0x97, 0xD5, 0x00, 0xAA, 0x00, 0x55, 0x59, 0x5A);
#endif

#ifdef USE_MEDIA_FOUNDATION
// IMFGetService FA993888-4383-415A-A930-DD472A8CF6F7}
#ifndef IID_IMFGetService
DEFINE_GUID(IID_IMFGetService , 0xFA993888, 0x4383, 0x415A, 0xA9, 0x30, 0xDD, 0x47, 0x2A, 0x8C, 0xF6, 0xF7); 
#endif
#endif

// Release
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(pOblect)			if((pOblect)) {(pOblect)->Release(); (pOblect) = NULL;}
#endif
#ifndef SAFE_RELEASE_EX
#define SAFE_RELEASE_EX(pOblect,nRef)	{nRef=0;if((pOblect)) {nRef=(pOblect)->Release(); (pOblect) = NULL;}}
#endif

class CDirectShowUtil
{
public:
	CDirectShowUtil(void);
	~CDirectShowUtil(void);

	void Clear();
	bool FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType=NULL,const CLSID *pidOutubType=NULL);
	bool PriorityFilterGoToHead(const CLSID idPriorityClass);
	bool IgnoreFilterGoToTail(const CLSID idIgnoreClass,bool bRemoveIt=false);
	int GetFilterCount();
	bool GetFilterInfo(const int iIndex,CLSID *pidClass=NULL,wchar_t *lpwszFriendryName=NULL,int iBufLen=0);
	
protected:
	struct DIRECTSHOW_FILTER_INFO {
		CStringW	friendry_name;
		CLSID		class_id;
	};
	CArray<DIRECTSHOW_FILTER_INFO> m_FilterClassID;

// ȉA֗֐
public:
// fobOp(se[uɒǉE폜)
// ERemoveFromRot()ɂGrapheditĂKv܂B
// EWindowsVistał̋@\gɂ́AWindows SDK for Vista  C:\Program Files\Microsoft SDKs\Windows\v6.0\Bin ɂ
//   proppage.dll  regsvr32 œo^ĂKv܂B
	static const HRESULT AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister)
	{
		IMoniker * pMoniker;
		IRunningObjectTable *pROT;
		if(FAILED(::GetRunningObjectTable(0, &pROT)))return E_FAIL;

		wchar_t wsz[256];
		swprintf_s(wsz,256, L"FilterGraph %08p pid %08x", (DWORD_PTR)pUnkGraph, ::GetCurrentProcessId());

		HRESULT hr = ::CreateItemMoniker(L"!", wsz, &pMoniker);

		if(SUCCEEDED(hr)){
			hr = pROT->Register(0, pUnkGraph, pMoniker, pdwRegister);
			pMoniker->Release();
			}		
		pROT->Release();
		return hr;
	};
	static void RemoveFromRot(const DWORD dwRegister)
	{		
		IRunningObjectTable *pROT;

		if(SUCCEEDED(::GetRunningObjectTable(0, &pROT))){
			pROT->Revoke(dwRegister);
			pROT->Release();
			}
	}

// \zp[eBeB
protected:
public:
	static IPin* GetFilterPin(IBaseFilter *pFilter, const PIN_DIRECTION dir, const AM_MEDIA_TYPE *pMediaType=NULL);
	static bool ShowPropertyPage(IBaseFilter *pFilter, HWND hWndParent);
	static bool AppendMpeg2Decoder_and_Connect(IGraphBuilder *pFilterGraph, CDirectShowUtil *pUtil, IBaseFilter **ppMpeg2DecoderFilter,wchar_t *lpszDecoderName,int iDecNameBufLen, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin=NULL);
	static bool AppendFilter_and_Connect(const CLSID guidFilter,const wchar_t *lpwszFilterName, IGraphBuilder *pFilterGraph, IBaseFilter **ppAppendedFilter, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin=NULL, bool fDirect=false);
	static bool AppendFilter_and_Connect(IBaseFilter *pFilter,const wchar_t *lpwszFilterName, IGraphBuilder *pFilterGraph, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin=NULL, bool fDirect=false);
	static bool AppendColorSpaceConverterFilter_and_Connect(IGraphBuilder *pFilterGraph, IBaseFilter **ppColorSpaceConverterFilter, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin=NULL);

// ėp[eBeB
protected:
public:
	static IVideoWindow* GetVideoWindow(IGraphBuilder *pGraph);
	static IBasicVideo2* GetBasicVideo2(IGraphBuilder *pGraph);
	static IMediaControl* GetMediaControl(IGraphBuilder *pGraph);
	static bool FilterGrapph_Play(IGraphBuilder *pFilterGraph) { bool bRet=false; if(pFilterGraph){	IMediaControl *pControl = GetMediaControl(pFilterGraph); if(pControl){ HRESULT hr = pControl->Run(); SAFE_RELEASE(pControl); bRet = true; } } return bRet; }
	static bool FilterGrapph_Stop(IGraphBuilder *pFilterGraph) { bool bRet=false; if(pFilterGraph){	IMediaControl *pControl = GetMediaControl(pFilterGraph); if(pControl){ HRESULT hr = pControl->Stop(); SAFE_RELEASE(pControl); bRet = true; } } return bRet; }
	static bool FilterGrapph_Pause(IGraphBuilder *pFilterGraph) { bool bRet=false; if(pFilterGraph){	IMediaControl *pControl = GetMediaControl(pFilterGraph); if(pControl){ HRESULT hr = pControl->Pause(); SAFE_RELEASE(pControl); bRet = true; } } return bRet; }

// tB^QƃJE^擾
	inline static int GetRefCount(IUnknown *pUkn) { if(!pUkn) { return 0;} else { pUkn->AddRef(); int ret = pUkn->Release(); return ret; } };

//////////////////////////////////////////////////////////////////////
// ȉ EVRp[eBeB
#ifdef USE_MEDIA_FOUNDATION
public:
	static void						MF_Init();
	static void						MF_Term();
	static IEVRFilterConfig*		MF_GetEVRFilterConfig(IBaseFilter *pEvr);
	static IMFGetService*			MF_GetService(IBaseFilter *pEvr);
	static bool						MF_SetNumberOfStreams(IBaseFilter *pEvr,int iStreamNumber=1);
	static IMFVideoDisplayControl*	MF_GetVideoDisplayControl(IBaseFilter *pEvr);
	static IMFVideoMixerControl*	MF_GetVideoMixerControl(IBaseFilter *pEvr);
	static IMFVideoProcessor*		MF_GetVideoProcessor(IBaseFilter *pEvr);

#endif
};
